Page Menu
Home
ClusterLabs Projects
Search
Configure Global Search
Log In
Files
F3151822
No One
Temporary
Actions
View File
Edit File
Delete File
View Transforms
Subscribe
Mute Notifications
Flag For Later
Award Token
Size
18 KB
Referenced Files
None
Subscribers
None
View Options
diff --git a/heartbeat/exportfs b/heartbeat/exportfs
index bc8e341c1..abc144c7f 100755
--- a/heartbeat/exportfs
+++ b/heartbeat/exportfs
@@ -1,341 +1,344 @@
#!/bin/sh
# exportfs
#
# Description: Manages nfs exported file system.
#
# (c) 2010 Ben Timby, Florian Haas, Dejan Muhamedagic,
# and Linux-HA contributors
#
# License: GNU General Public License v2 (GPLv2) and later
#######################################################################
# Initialization:
: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
# Defaults
OCF_RESKEY_unlock_on_stop_default=0
OCF_RESKEY_wait_for_leasetime_on_stop_default=0
OCF_RESKEY_rmtab_backup_default=".rmtab"
: ${OCF_RESKEY_unlock_on_stop=${OCF_RESKEY_unlock_on_stop_default}}
: ${OCF_RESKEY_wait_for_leasetime_on_stop=${OCF_RESKEY_wait_for_leasetime_on_stop_default}}
: ${OCF_RESKEY_rmtab_backup=${OCF_RESKEY_rmtab_backup_default}}
#######################################################################
exportfs_meta_data() {
cat <<END
<?xml version="1.0"?>
<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
<resource-agent name="exportfs">
<version>1.0</version>
<longdesc lang="en">
Exportfs uses the exportfs command to add/remove nfs exports.
It does NOT manage the nfs server daemon.
It depends on Linux specific NFS implementation details,
so is considered not portable to other platforms yet.
</longdesc>
<shortdesc lang="en">
Manages NFS exports
</shortdesc>
<parameters>
<parameter name="clientspec" unique="0" required="1">
<longdesc lang="en">
The client specification allowing remote machines to mount the directory
over NFS.
</longdesc>
<shortdesc lang="en">
Client ACL.
</shortdesc>
<content type="string" />
</parameter>
<parameter name="options" unique="0" required="0">
<longdesc lang="en">
The options to pass to exportfs for the exported directory.
</longdesc>
<shortdesc lang="en">
Export options.
</shortdesc>
<content type="string" />
</parameter>
<parameter name="directory" unique="0" required="1">
<longdesc lang="en">
The directory which you wish to export using NFS.
</longdesc>
<shortdesc lang="en">
The directory to export.
</shortdesc>
<content type="string" />
</parameter>
<parameter name="fsid" unique="1" required="1">
<longdesc lang="en">
The fsid option to pass to exportfs. This can be a unique positive
integer, a UUID, or the special string "root" which is functionally
identical to numeric fsid of 0.
0 (root) identifies the export as the root of an NFSv4
pseudofilesystem -- avoid this setting unless you understand its
special status.
This value will override any fsid provided via the options parameter.
</longdesc>
<shortdesc lang="en">
Unique fsid within cluster.
</shortdesc>
<content type="string" />
</parameter>
<parameter name="unlock_on_stop">
<longdesc lang="en">
Relinquish NFS locks associated with this filesystem when the resource
stops. Enabling this parameter is highly recommended unless the path exported
by this ${__SCRIPT_NAME} resource is also exported by a different resource.
</longdesc>
<shortdesc lang="en">
Unlock filesystem on stop?
</shortdesc>
<content type="boolean" default="${OCF_RESKEY_unlock_on_stop_default}" />
</parameter>
<parameter name="wait_for_leasetime_on_stop">
<longdesc lang="en">
When stopping (unexporting), wait out the NFSv4 lease time.
Only after all leases have expired does the NFS kernel server
relinquish all server-side handles on the exported filesystem.
If this ${__SCRIPT_NAME} resource manages an export that resides
on a mount point designed to fail over along with the NFS export
itself, then enabling this parameter will ensure such failover
is working properly. Note that when this parameter is set, your
stop timeout MUST accommodate for the wait period. This parameter
is safe to disable if none of your NFS clients are using NFS
version 4 or later.
</longdesc>
<shortdesc lang="en">
Ride out the NFSv4 lease time on resource stop?
</shortdesc>
<content type="boolean" default="${OCF_RESKEY_wait_for_leasetime_on_stop_default}" />
</parameter>
<parameter name="rmtab_backup">
<longdesc lang="en">
Back up those entries from the NFS rmtab that apply to the exported
directory, to the specified backup file. The filename is interpreted
as relative to the exported directory. This backup is required if
clients are connecting to the export via NFSv3 over TCP. Note that a
configured monitor operation is required for this functionality.
To disable rmtab backups, set this parameter to the special
string "none".
</longdesc>
<shortdesc lang="en">
Location of the rmtab backup, relative to directory.
</shortdesc>
<content type="string" default="${OCF_RESKEY_rmtab_backup_default}" />
</parameter>
</parameters>
<actions>
<action name="start" timeout="40" />
<action name="stop" timeout="10" />
<action name="monitor" depth="0" timeout="20" interval="10" />
<action name="meta-data" timeout="5" />
<action name="validate-all" timeout="30" />
</actions>
</resource-agent>
END
return $OCF_SUCCESS
}
backup_rmtab() {
local rmtab_backup
if [ ${OCF_RESKEY_rmtab_backup} != "none" ]; then
rmtab_backup="${OCF_RESKEY_directory}/${OCF_RESKEY_rmtab_backup}"
grep ":${OCF_RESKEY_directory}:" /var/lib/nfs/rmtab > ${rmtab_backup}
fi
}
restore_rmtab() {
local rmtab_backup
if [ ${OCF_RESKEY_rmtab_backup} != "none" ]; then
rmtab_backup="${OCF_RESKEY_directory}/${OCF_RESKEY_rmtab_backup}"
if [ -r ${rmtab_backup} ]; then
cat ${rmtab_backup} >> /var/lib/nfs/rmtab
ocf_log debug "Restored `wc -l ${rmtab_backup}` rmtab entries from ${rmtab_backup}."
else
ocf_log warn "rmtab backup ${rmtab_backup} not found or not readable."
fi
fi
}
exportfs_usage() {
cat <<END
usage: $0 {start|stop|monitor|status|validate-all|meta-data}
END
}
exportfs_monitor ()
{
- # "grep -z" matches across newlines, which is necessary as
- # exportfs output wraps lines for long export directory names
- exportfs | grep -zqs "${OCF_RESKEY_directory}[[:space:]]*${OCF_RESKEY_clientspec}"
+ # exportfs output wraps lines for long export directory names.
+ # We unwrap here with sed.
+ # We then do a literal match on the full line (grep -x -F)
+ exportfs |
+ sed -e '$! N; s/\n[[:space:]]\+/ /; t; s/[[:space:]]\+\([^[:space:]]\+\)\(\n\|$\)/ \1\2/g; P;D;' |
+ grep -q -x -F "${OCF_RESKEY_directory} ${OCF_RESKEY_clientspec}"
#Adapt grep status code to OCF return code
case $? in
0)
ocf_log info "Directory ${OCF_RESKEY_directory} is exported to ${OCF_RESKEY_clientspec} (started)."
# Backup the rmtab to ensure smooth NFS-over-TCP failover
backup_rmtab
return $OCF_SUCCESS
;;
1)
ocf_log info "Directory ${OCF_RESKEY_directory} is not exported to ${OCF_RESKEY_clientspec} (stopped)."
return $OCF_NOT_RUNNING;;
*)
ocf_log err "Unable to determine export status for ${OCF_RESKEY_directory}."
return $OCF_ERR_GENERIC;;
esac
}
exportfs_start ()
{
if exportfs_monitor; then
ocf_log debug "${OCF_RESKEY_directory} already exported"
return $OCF_SUCCESS
fi
ocf_log info "Exporting file system ..."
if [ ${OCF_RESKEY_options} ]; then
OPTIONS="${OCF_RESKEY_options}"
OPTPREFIX=','
fi
if [ `echo ${OPTIONS} | grep fsid` ]; then
#replace fsid provided in options list with one provided in fsid param.
OPTIONS=`echo ${OPTIONS} | sed "s/fsid=[0-9]\+/fsid=${OCF_RESKEY_fsid}/g"`
else
#tack the fsid option onto our options list.
OPTIONS="${OPTIONS}${OPTPREFIX}fsid=${OCF_RESKEY_fsid}"
fi
OPTIONS="-o ${OPTIONS}"
ocf_run exportfs -v ${OPTIONS} ${OCF_RESKEY_clientspec}:${OCF_RESKEY_directory} || exit $OCF_ERR_GENERIC
# Restore the rmtab to ensure smooth NFS-over-TCP failover
restore_rmtab
ocf_log info "File system exported"
return $OCF_SUCCESS
}
exportfs_stop ()
{
exportfs_monitor
if [ $? -eq $OCF_NOT_RUNNING ]; then
ocf_log debug "${OCF_RESKEY_directory} not exported"
return $OCF_SUCCESS
fi
ocf_log info "Un-exporting file system ..."
# Backup the rmtab to ensure smooth NFS-over-TCP failover
backup_rmtab
ocf_run exportfs -v -u ${OCF_RESKEY_clientspec}:${OCF_RESKEY_directory}
rc=$?
if ocf_is_true ${OCF_RESKEY_unlock_on_stop}; then
local unlockfile
unlockfile=/proc/fs/nfsd/unlock_filesystem
if [ -w ${unlockfile} ]; then
echo "${OCF_RESKEY_directory}" > ${unlockfile}
ocf_log info "Unlocked NFS export ${OCF_RESKEY_directory}"
else
ocf_log warn "Unable to unlock NFS export ${OCF_RESKEY_directory}, ${unlockfile} not found or not writable"
fi
fi
if ocf_is_true ${OCF_RESKEY_wait_for_leasetime_on_stop}; then
local leasetimefile
local sleeptime
leasetimefile=/proc/fs/nfsd/nfsv4leasetime
if [ -r ${leasetimefile} ]; then
sleeptime=$((`cat ${leasetimefile}`+2))
ocf_log info "Sleeping ${sleeptime} seconds to accommodate for NFSv4 lease expiry"
sleep ${sleeptime}s
else
ocf_log warn "Unable to read NFSv4 lease time from ${leasetimefile}, file not found or not readable"
fi
fi
if [ $rc -eq 0 ]; then
ocf_log info "Un-exported file system"
return $OCF_SUCCESS
fi
ocf_log err "Failed to un-export file system"
exit $OCF_ERR_GENERIC
}
exportfs_validate ()
{
# Checks for required parameters
if [ -z "$OCF_RESKEY_directory" ]; then
ocf_log err "Missing required parameter \"directory\""
exit $OCF_ERR_CONFIGURED
fi
if [ -z "$OCF_RESKEY_fsid" ]; then
ocf_log err "Missing required parameter \"fsid\""
exit $OCF_ERR_CONFIGURED
fi
if [ -z "$OCF_RESKEY_clientspec" ]; then
ocf_log err "Missing required parameter \"clientspec\""
exit $OCF_ERR_CONFIGURED
fi
# Checks applicable only to non-probes
if ! ocf_is_probe; then
if [ ! -d $OCF_RESKEY_directory ]; then
ocf_log err "$OCF_RESKEY_directory does not exist or is not a directory"
exit $OCF_ERR_INSTALLED
fi
fi
}
if [ $# -ne 1 ]; then
exportfs_usage
exit $OCF_ERR_ARGS
fi
case $__OCF_ACTION in
meta-data) exportfs_meta_data
exit $OCF_SUCCESS
;;
usage|help) exportfs_usage
exit $OCF_SUCCESS
;;
*)
;;
esac
exportfs_validate
case $__OCF_ACTION in
start) exportfs_start
;;
stop) exportfs_stop
;;
status|monitor) exportfs_monitor
;;
validate-all)
# nothing to do -- we're already validated
;;
*) exportfs_usage
exit $OCF_ERR_UNIMPLEMENTED
;;
esac
diff --git a/resource-agents.spec.in b/resource-agents.spec.in
index b78d30868..15c6aeb58 100644
--- a/resource-agents.spec.in
+++ b/resource-agents.spec.in
@@ -1,305 +1,303 @@
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.
#
%global rcver @rcver@
%global alphatag @alphatag@
%global numcomm @numcomm@
%global dirty @dirty@
#
# Since this spec file supports multiple distributions, ensure we
# use the correct group for each.
#
# SSLeay (required by ldirectord)
%if 0%{?suse_version}
%global SSLeay perl-Net_SSLeay
%else
%global SSLeay perl-Net-SSLeay
%endif
# determine the ras-set to process based on configure invokation
%bcond_@rgmanager@ rgmanager
%bcond_@linux-ha@ linuxha
Name: resource-agents
Summary: Open Source HA Reusable Cluster Resource Scripts
Version: @version@
Release: @specver@%{?rcver:%{rcver}}%{?numcomm:.%{numcomm}}%{?alphatag:.%{alphatag}}%{?dirty:.%{dirty}}%{?dist}
License: GPLv2+ and LGPLv2+
URL: http://to.be.defined.com/
%if 0%{?fedora} || 0%{?centos_version} || 0%{?rhel}
Group: System Environment/Base
%else
Group: Productivity/Clustering/HA
%endif
Source0: %{name}-%{version}%{?rcver:%{rcver}}%{?numcomm:.%{numcomm}}%{?alphatag:-%{alphatag}}%{?dirty:-%{dirty}}.tar.bz2
Obsoletes: heartbeat-resources <= %{version}
Provides: heartbeat-resources = %{version}
## Setup/build bits
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
# Build dependencies
BuildRequires: automake autoconf pkgconfig
BuildRequires: perl python-devel
BuildRequires: libxslt glib2-devel
BuildRequires: which
%if 0%{?fedora} || 0%{?centos_version} || 0%{?rhel}
BuildRequires: cluster-glue-libs-devel
BuildRequires: docbook-style-xsl docbook-dtds
%if 0%{?rhel} == 0
BuildRequires: libnet-devel
%endif
%endif
%if 0%{?suse_version}
%if 0%{?suse_version} >= 1140
BuildRequires: libnet1
%else
BuildRequires: libnet
%endif
BuildRequires: libglue-devel
BuildRequires: libxslt docbook_4 docbook-xsl-stylesheets
%endif
## Runtime deps
## These apply to rgmanager agents only to guarantee agents
## are functional
%if %{with rgmanager}
# system tools shared by several agents
Requires: /bin/bash /bin/grep /bin/sed /bin/gawk
Requires: /bin/ps /usr/bin/pkill /bin/hostname
Requires: /sbin/fuser
Requires: /sbin/findfs /bin/mount
# fs.sh
Requires: /sbin/quotaon /sbin/quotacheck
Requires: /sbin/fsck
Requires: /sbin/fsck.ext2 /sbin/fsck.ext3 /sbin/fsck.ext4
Requires: /sbin/fsck.xfs
# ip.sh
Requires: /sbin/ip /usr/sbin/ethtool
Requires: /sbin/rdisc /usr/sbin/arping /bin/ping /bin/ping6
# lvm.sh
Requires: /sbin/lvm
# netfs.sh
Requires: /sbin/mount.nfs /sbin/mount.nfs4 /sbin/mount.cifs
Requires: /usr/sbin/rpc.nfsd /sbin/rpc.statd /usr/sbin/rpc.mountd
%endif
%description
A set of scripts to interface with several services to operate in a
High Availability environment for both Pacemaker and rgmanager
service managers.
%if %{with linuxha}
%package -n ldirectord
License: GPLv2+
Summary: A Monitoring Daemon for Maintaining High Availability Resources
%if 0%{?fedora} || 0%{?centos_version} || 0%{?rhel}
Group: System Environment/Daemons
%else
Group: Productivity/Clustering/HA
%endif
Obsoletes: heartbeat-ldirectord <= %{version}
Provides: heartbeat-ldirectord = %{version}
Requires: %{SSLeay} perl-libwww-perl perl-MailTools
Requires: ipvsadm logrotate
%if 0%{?fedora_version}
Requires: perl-Net-IMAP-Simple-SSL
Requires(post): /sbin/chkconfig
Requires(preun):/sbin/chkconfig
%endif
%description -n ldirectord
The Linux Director Daemon (ldirectord) was written by Jacob Rief.
<jacob.rief@tiscover.com>
ldirectord is a stand alone daemon for monitoring the services on real
servers. Currently, HTTP, HTTPS, and FTP services are supported.
lditrecord is simple to install and works with the heartbeat code
(http://www.linux-ha.org/).
See 'ldirectord -h' and linux-ha/doc/ldirectord for more information.
%endif
%prep
%if 0%{?suse_version} == 0 && 0%{?fedora} == 0 && 0%{?centos_version} == 0 && 0%{?rhel} == 0
%{error:Unable to determine the distribution/version. This is generally caused by missing /etc/rpm/macros.dist. Please install the correct build packages or define the required macros manually.}
exit 1
%endif
%setup -q -n %{name}-%{version}%{?rcver:%{rcver}}%{?numcomm:.%{numcomm}}%{?alphatag:-%{alphatag}}%{?dirty:-%{dirty}}
%build
if [ ! -f configure ]; then
./autogen.sh
fi
%if 0%{?fedora} >= 11 || 0%{?centos_version} > 5 || 0%{?rhel} > 5
CFLAGS="$(echo '%{optflags}')"
%global conf_opt_fatal "--enable-fatal-warnings=no"
%else
CFLAGS="${CFLAGS} ${RPM_OPT_FLAGS}"
%global conf_opt_fatal "--enable-fatal-warnings=yes"
%endif
%if %{with rgmanager}
%global rasset rgmanager
%endif
%if %{with linuxha}
%global rasset linux-ha
%endif
%if %{with rgmanager} && %{with linuxha}
%global rasset all
%endif
export CFLAGS
%configure \
%{?conf_opt_rsctmpdir:%conf_opt_rsctmpdir} \
%{conf_opt_fatal} \
--with-pkg-name=%{name} \
--with-ras-set=%{rasset}
%if %{defined jobs}
JFLAGS="$(echo '-j%{jobs}')"
%else
JFLAGS="$(echo '%{_smp_mflags}')"
%endif
make $JFLAGS
%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
## tree fixup
# remove docs (there is only one and they should come from doc sections in files)
rm -rf %{buildroot}/usr/share/doc/resource-agents
%if %{with linuxha}
%if 0%{?suse_version}
test -d %{buildroot}/sbin || mkdir %{buildroot}/sbin
(
cd %{buildroot}/sbin
ln -sf /%{_sysconfdir}/init.d/ldirectord rcldirectord
) || true
%endif
%endif
%clean
rm -rf %{buildroot}
%files
%defattr(-,root,root)
%doc AUTHORS COPYING COPYING.GPLv3 ChangeLog
%if %{with linuxha}
%doc doc/README.webapps
%doc %{_datadir}/%{name}/ra-api-1.dtd
%endif
%if %{with rgmanager}
%{_datadir}/cluster
%{_sbindir}/rhev-check.sh
%endif
%if %{with linuxha}
%dir /usr/lib/ocf
%dir /usr/lib/ocf/resource.d
%dir /usr/lib/ocf/lib
/usr/lib/ocf/lib/heartbeat
/usr/lib/ocf/resource.d/heartbeat
%if %{with rgmanager}
/usr/lib/ocf/resource.d/redhat
%endif
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/ocft
%{_datadir}/%{name}/ocft/configs
%{_datadir}/%{name}/ocft/caselib
%{_datadir}/%{name}/ocft/README
%{_datadir}/%{name}/ocft/README.zh_CN
%{_sbindir}/ocf-tester
%{_sbindir}/ocft
%{_sbindir}/sfex_init
%{_sbindir}/sfex_stat
%{_includedir}/heartbeat
%dir %attr (1755, root, root) %{_var}/run/resource-agents
%{_mandir}/man7/*.7*
%{_mandir}/man8/ocf-tester.8*
%{_mandir}/man8/sfex_init.8*
# For compatability with pre-existing agents
%dir %{_sysconfdir}/ha.d
%{_sysconfdir}/ha.d/shellfuncs
%{_libdir}/heartbeat
-%if %{with rgmanager}
%post -n resource-agents
+if [ $1 = 2 ]; then
+ if [ -d %{_var}/run/heartbeat/rsctmp ]; then
+ cp -fpr %{_var}/run/heartbeat/rsctmp/* %{_var}/run/resource-agents/ 1>/dev/null 2>&1
+ rm -fr %{_var}/run/heartbeat/rsctmp
+ fi
+fi
+%if %{with rgmanager}
ccs_update_schema > /dev/null 2>&1 ||:
%endif
%if 0%{?suse_version}
%preun -n ldirectord
%stop_on_removal ldirectord
%postun -n ldirectord
%insserv_cleanup
%endif
%if 0%{?fedora}
%preun -n ldirectord
/sbin/chkconfig --del ldirectord
%postun -n ldirectord -p /sbin/ldconfig
%post -n ldirectord
/sbin/chkconfig --add ldirectord
%endif
%files -n ldirectord
%defattr(-,root,root)
%{_sbindir}/ldirectord
%doc ldirectord/ldirectord.cf COPYING
%{_mandir}/man8/ldirectord.8*
%config(noreplace) %{_sysconfdir}/logrotate.d/ldirectord
%dir %{_sysconfdir}/ha.d
%dir %{_sysconfdir}/ha.d/resource.d
%{_sysconfdir}/ha.d/resource.d/ldirectord
%{_sysconfdir}/init.d/ldirectord
%if 0%{?suse_version}
/sbin/rcldirectord
%endif
%if 0%{?fedora}
/usr/lib/ocf/resource.d/heartbeat/ldirectord
%endif
%endif
-%post
-if [ $1 = 2 ]; then
-if [ -d %{_var}/run/heartbeat/rsctmp ]; then
-cp -fpr %{_var}/run/heartbeat/rsctmp/* %{_var}/run/resource-agents/
-rm -fr %{_var}/run/heartbeat/rsctmp
-fi
-fi
-
%changelog
* @date@ Autotools generated version <nobody@nowhere.org> - @version@-@specver@-@numcomm@.@alphatag@.@dirty@
- Autotools generated version
File Metadata
Details
Attached
Mime Type
text/x-diff
Expires
Mon, Feb 24, 11:31 AM (18 h, 35 m ago)
Storage Engine
blob
Storage Format
Raw Data
Storage Handle
1459755
Default Alt Text
(18 KB)
Attached To
Mode
rR Resource Agents
Attached
Detach File
Event Timeline
Log In to Comment